/*******************************************************************************
 * {COPYRIGHT-TOP} *** * IBM Confidential * OCO Source Materials 5725-E59
 * 
 * (c) Copyright IBM Corp. 2012 All Rights Reserved.
 * 
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright Office.
 ******************************************************************************/
define([ "dojo/_base/declare", "dijit/_Widget", "dijit/_Templated",
        "dojo/text!./templates/ErrorWidget.html",

        "dojo/dom-construct", "dojo/dom-class", "dojo/dom-style",

        "dojo/_base/lang", "dojo/_base/array" ],
        function(declare, _Widget, _Templated, template, domConstruct,
                domClass, domStyle, lang, baseArray) {

            /**
             * The module wodm.decisions.ErrorWidget provides a generic Widget
             * to display inline errors.
             */
            var ErrorWidget = declare("wodm.decisions.ErrorWidget", [ _Widget,
                    _Templated ], {
                templateString : template,

                baseClass : "wodmDecisionErrorWidget",

                /**
                 * Array of error messages to display.
                 */
                errors : null,

                postCreate : function() {

                    this.inherited(arguments);
                    var errorMessagesDiv = this._errorMessagesDiv;
                    baseArray.forEach(this.errors, function(error) {

                        var div = domConstruct.create("div");
                        div.innerHTML = error;
                        domClass.add(div, "errorMessage");
                        errorMessagesDiv.appendChild(div);

                    });

                }

            });
            return ErrorWidget;

        });