/*******************************************************************************
 * {COPYRIGHT-TOP} *** * IBM Confidential * OCO Source Materials 5725-E59
 * 
 * (c) Copyright IBM Corp. 2012 All Rights Reserved.
 * 
 * The source code for this program is not published or otherwise divested of
 * its trade secrets, irrespective of what has been deposited with the U.S.
 * Copyright Office.
 ******************************************************************************/
define(
        [ "dojo/_base/declare", "dijit/_Widget", "dijit/_Templated",
                "dojo/text!./templates/loginFormTemplate.html",
                "dojo/i18n!wodm/decisions/nls/LoginForm", "dojo/_base/xhr",
                "dojo/dom-construct", "dojo/dom-class",
                "wodm/decisions/ErrorWidget", "dijit/form/TextBox",
                "dijit/form/Button" ],
        function(declare, _Widget, _Templated, template, i18nResources, xhr,
                domConstruct, domClass, ErrorWidget) {

            /**
             * The module wodm.decisions.LoginForm provides a form for the user
             * to log into the WODM system..
             */
            var LoginForm = declare(
                    "wodm.decisions.LoginForm",
                    [ _Widget, _Templated ],
                    {
                        templateString : template,
                        widgetsInTemplate : true,

                        baseClass : "wodmDecisionsLoginForm",

                        /**
                         * URLS for various xhr requests/navigation links for
                         * the WODM Login Form Widget.
                         */
                        _urls : {

                            LOGIN : "wodmLogin.wpc"

                        },

                        postMixInProperties : function() {

                            this.inherited(arguments);
                            this._i18nResources = i18nResources;

                        },

                        /**
                         * Object containing reference to the ErrorWidget for
                         * displaying errors.
                         */
                        _errorWidget : null,

                        /**
                         * Handler for the onclick event of the Login Button on
                         * the form.
                         */
                        _onLoginBtnClick : function() {

                            this._sendLoginRequest();
                        },

                        /**
                         * Sends an xhr request to the server to log in the user
                         * using WODM credentials.
                         */
                        _sendLoginRequest : function() {

                            if (this._errorNode) {
                                domConstruct.destroy(this._errorNode);
                                this._errorNode = null;
                            }
                            var _self = this;
                            xhr
                                    .post({
                                        url : this._urls.LOGIN,
                                        handleAs : "json",
                                        content : {
                                            userName : this.userNameTxtBox
                                                    .get("value"),
                                            pwd : this.passwordTxtBox
                                                    .get("value")

                                        },

                                        load : function(result) {
                                            if (result.status === false) {

                                                if (_self._errorWidget) {

                                                    domConstruct
                                                            .destroy(_self._errorWidget.domNode);
                                                    _self._errorWidget = null;
                                                }
                                                var errors = [];
                                                if(null !== result.error)
                                                {
                                                    errors.push(result.error);
                                                }else
                                                {
                                                    errors.push(_self._i18nResources.INVALID_CREDENTIALS_MESSAGE);
                                                }
                                                var errorWidget = new ErrorWidget(
                                                        {
                                                           errors : errors
                                                        });
                                                _self._errorWidget = errorWidget;
                                                _self.errorPlaceHolder
                                                        .appendChild(errorWidget.domNode);

                                            } else {

                                                _self.onLoginSuccess();
                                            }
                                        }

                                    });

                        },

                        /**
                         * Connect to it to provide functionality.
                         */
                        onLoginSuccess : function() {

                        }

                    });
            return LoginForm;

        });